<template>
  <div class="page-box" style="position: relative;">
    <el-form
      ref="formBannerInfo"
      :model="formData"
      :size="layoutStore.defaultFormItemSize"
      label-width="120px"
      label-position="right"
      @submit.prevent
    >
      <filter-box :item-width="350" @search="refreshFormBannerInfo()" @reset="resetFormBannerInfo">
        <el-form-item label="banner名称">
          <el-input
            class="filter-item"
            v-model="formFilter.bannerNameFilter"
            type="text"
            placeholder=""
            :clearable="true"
            :show-word-limit="false"
            maxlength=""
          />
        </el-form-item>
        <el-form-item label="所属分类">
          <el-cascader
            class="filter-item"
            v-model="formFilter.belongTabFilter"
            :options="belongTabFilterWidgetDropdownList"
            placeholder=""
            :clearable="true"
            :filterable="true"
            :show-all-levels="false"
            :props="{ value: 'id', label: 'name', children: 'children', checkStrictly: true }"
            @change="onBelongTabFilterValueChange"
          />
        </el-form-item>
      </filter-box>
    </el-form>
    <table-box
      ref="formBannerInfoTable"
      class="page-table"
      :data="formBannerInfoTableWidgetDataList"
      :size="layoutStore.defaultFormItemSize"
      :row-config="{isCurrent: false, isHover: true}"
      :seq-config="{startIndex: ((formBannerInfoTableWidgetCurrentPage - 1) * formBannerInfoTableWidgetPageSize)}"
      :sort-config="{remote: true}"
      :hasExtend="true"
      @sort-change="formBannerInfoTableWidget.onSortChange"
      @refresh="formBannerInfoTableWidget.refreshTable()"
    >
      <template #operator>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          :disabled="!checkPermCodeExist('formBannerInfo:formBannerInfo:addBannerInfo')"
          @click="onAddBannerInfoClick()"
          >
          新建
        </el-button>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          :disabled="!checkPermCodeExist('formBannerInfo:formBannerInfo:exportBannerInfo')"
          @click="onExportBannerInfoClick()"
          >
          导出
        </el-button>
        <el-upload
          class="btn-import"
          :auto-upload="false"
          action=""
          :show-file-list="false"
          accept=".xls,.xlsx"
          style="display: inline-block;"
          :disabled="!checkPermCodeExist('formBannerInfo:formBannerInfo:importBannerInfo')"
          :on-change="onImportBannerInfoClick"
        >
          <template #trigger>
            <el-button
              type="primary"
              :size="layoutStore.defaultFormItemSize"
              :disabled="!checkPermCodeExist('formBannerInfo:formBannerInfo:importBannerInfo')"
            >
              导入
            </el-button>
          </template>
        </el-upload>
      </template>
      <vxe-column title="序号" type="seq" :index="formBannerInfoTableWidget.getTableIndex" :width="80" />
      <vxe-column title="banner名称" field="bannerName" />
      <vxe-column title="所属分类" field="belongTabDictMap.name" />
      <vxe-column title="是否启用" field="enableDictMap.name" />
      <vxe-column title="是否主banner" field="mainBannerDictMap.name" />
      <vxe-column title="banner排序" field="showOrder" />
      <vxe-column title="图片" min-width="100px">
        <template v-slot="scope">
          <el-image v-for="item in parseUploadData(scope.row.imgUrl, { id: scope.row.id, fieldName: 'imgUrl', asImage: true })"
            :preview-src-list="getPictureList(scope.row.imgUrl, { id: scope.row.id, fieldName: 'imgUrl', asImage: true })"
            class="table-cell-image" :key="item.url" :src="item.url" fit="fill">
            <template #error>
              <div class="table-cell-image">
                <i class="el-icon-picture-outline"></i>
              </div>
            </template>
          </el-image>
        </template>
      </vxe-column>
      <vxe-column title="操作" fixed="right">
        <template v-slot="scope">
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onEditBannerInfoClick(scope.row)"
            :disabled="!checkPermCodeExist('formBannerInfo:formBannerInfo:editBannerInfo')"
          >
            编辑
          </el-button>
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onDeleteBannerInfoClick(scope.row)"
            :disabled="!checkPermCodeExist('formBannerInfo:formBannerInfo:deleteBannerInfo')"
          >
            删除
          </el-button>
        </template>
      </vxe-column>
      <template slot="empty">
        <div class="table-empty unified-font">
          <img src="@/assets/img/empty.png">
          <span>暂无数据</span>
        </div>
      </template>
      <!-- 分页 -->
      <template #pagination>
        <el-row type="flex" justify="end" style="margin-top: 10px;">
          <el-pagination
            :total="formBannerInfoTableWidgetTotalCount"
            :current-page="formBannerInfoTableWidgetCurrentPage"
            :page-size="formBannerInfoTableWidgetPageSize"
            :page-sizes="[10, 20, 50, 100]"
            layout="total, prev, pager, next, sizes"
            @current-change="formBannerInfoTableWidget.onCurrentPageChange"
            @size-change="formBannerInfoTableWidget.onPageSizeChange">
          </el-pagination>
        </el-row>
      </template>
    </table-box>
    <label v-if="subPage" class="page-close-box" @click="onCancel()">
      <img src="@/assets/img/back2.png" alt="">
    </label>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formBannerInfo',
};
</script>

<script setup lang="ts">
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode } from '@/common/utils';
import { BannerInfoData } from '@/api/generated/bannerInfoController';
import { BannerInfoController } from '@/api/generated';
import FormEditBannerInfo from '@/pages/bannerInfo/formEditBannerInfo.vue';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
  }>(),
  {
    subPage: 0,
  },
);

const formFilter = reactive({
  // banner名称
  bannerNameFilter: undefined,
  // 所属分类
  belongTabFilter: undefined,
});
const formFilterCopy = reactive({
  // banner名称
  bannerNameFilter: undefined,
  // 所属分类
  belongTabFilter: undefined,
});

const onCancel = () => {
  layoutStore.removeCachePage(route.name as string);
  route.meta.refreshParentCachedPage = true;
  router.go(-1);
};

const onResume = () => {
  refreshFormBannerInfo();
};

/**
 * 表格组件数据获取函数，返回Promise
 */
const loadFormBannerInfoTableWidgetData = (params: ANY_OBJECT) => {
  if (params == null) params = {};
  params = {
    ...params,
    bannerInfoDtoFilter: {
      bannerName: formFilter.bannerNameFilter,
      belongTab: formFilter.belongTabFilter
    }
  };
  return new Promise((resolve, reject) => {
    BannerInfoController.list(params).then(res => {
      resolve({
        dataList: res.data.dataList,
        totalCount: res.data.totalCount
      });
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 表格组件数据获取检测函数，返回true正常获取数据，返回false停止获取数据
 */
const loadFormBannerInfoTableVerify = () => {
  formFilterCopy.bannerNameFilter = formFilter.bannerNameFilter;
  formFilterCopy.belongTabFilter = formFilter.belongTabFilter;
  return true;
};
/**
 * 新建
 */
const onAddBannerInfoClick = (row?: BannerInfoData) => {
  let params: ANY_OBJECT = {
  };

  Dialog
    .show('新建', FormEditBannerInfo, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formBannerInfoTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 编辑
 */
const onEditBannerInfoClick = (row?: BannerInfoData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  Dialog
    .show('编辑', FormEditBannerInfo, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formBannerInfoTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 导出
 */
const onExportBannerInfoClick = (row?: BannerInfoData) => {
  let params: ANY_OBJECT = {
    bannerInfoDtoFilter: {
      bannerName: formFilter.bannerNameFilter,
      belongTab: formFilter.belongTabFilter,
    }
  };

  BannerInfoController.export(params, '表格组件.xlsx').then(res => {
    ElMessage.success('导出成功');
  }).catch(e => {
    ElMessage.error(e.errorMessage);
  });
};
/**
 * 导入
 */
const onImportBannerInfoClick = (file) => {
  let params: ANY_OBJECT = {
    importFile: file.raw,
    // 是否忽略表头
    skipHeader: false
  };

  BannerInfoController.import(params).then(res => {
    ElMessage.success('导入成功');
    formBannerInfoTableWidget.refreshTable();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
/**
 * 删除
 */
const onDeleteBannerInfoClick = (row?: BannerInfoData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  ElMessageBox.confirm('是否删除此记录？').then(res => {
    BannerInfoController.delete(params).then(res => {
      ElMessage.success('删除成功');
      formBannerInfoTableWidget.refreshTable(false, 1);
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
// 表格组件表格组件参数
const formBannerInfoTableOptions: TableOptions<BannerInfoData> = {
  loadTableData: loadFormBannerInfoTableWidgetData,
  verifyTableParameter: loadFormBannerInfoTableVerify,
  paged: true,
  rowSelection: false,
  orderFieldName: 'mainBanner',
  ascending: false,
};
// 表格组件表格组件
const formBannerInfoTable = ref();
const formBannerInfoTableWidget = useTable(formBannerInfoTableOptions);
const {
  dataList: formBannerInfoTableWidgetDataList,
  currentPage: formBannerInfoTableWidgetCurrentPage,
  pageSize: formBannerInfoTableWidgetPageSize,
  totalCount: formBannerInfoTableWidgetTotalCount,
} = formBannerInfoTableWidget;
/**
 * 所属分类下拉数据获取函数
 */
const loadBelongTabFilterDropdownList = (): Promise<ListData<DictData>> => {
  return new Promise((resolve, reject) => {
    const params = {
      parentId: 0
    };
    DictionaryController.dictDirectoryInfoByParentId(params).then(res => {
      resolve({
        dataList: res.getList(),
      });
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 所属分类选中值改变
 */
const onBelongTabFilterValueChange = (value) => {
  formFilter.belongTabFilter = Array.isArray(value) ? value[value.length - 1] : value;
};
// 所属分类配置参数
const belongTabFilterOptions: DropdownOptions<DictData> = {
  loadData: loadBelongTabFilterDropdownList,
  isTree: true,
};
// 所属分类选中数据
const belongTabFilterPath = ref<Array<string | number>>([]);
// 所属分类下拉组件
const belongTabFilterWidget = useDropdown(belongTabFilterOptions);
const { dropdownList: belongTabFilterWidgetDropdownList } = belongTabFilterWidget
const refreshFormBannerInfo = () => {
  // 刷新段落
  formBannerInfoTableWidget.refreshTable();
};
/**
 * 重置过滤值
 */
const resetFormBannerInfo = () => {
  formFilter.bannerNameFilter = undefined;
  formFilterCopy.bannerNameFilter = undefined;
  formFilter.belongTabFilter = undefined;
  formFilterCopy.belongTabFilter = undefined;
  belongTabFilterPath.value = [];
  refreshFormBannerInfo();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormBannerInfo();
};
const formInit = () => {
  belongTabFilterWidget.onVisibleChange(true).then(res => {
    // TODO: 获取级联选中路径
    belongTabFilterPath.value = findTreeNodePath(res, formFilter.belongTabFilter);
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
  refreshFormBannerInfo();
};

onMounted(() => {
  formInit();
});
</script>